unit UnidadMenuPrincipal;

{$R WinXP.res}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons, inifiles, TrayIcon,
  ActnList, Menus, ImgList, registry, shellapi, ThemeMgr;

type
  TformMenuPrincipal = class(TForm)
    tMin: TTrayIcon;
    bMinimizar: TBitBtn;
    bCerrar: TBitBtn;
    PopupMenu1: TPopupMenu;
    Mostrar1: TMenuItem;
    N1: TMenuItem;
    Cerrar1: TMenuItem;
    listaAcciones: TActionList;
    actCerrar: TAction;
    actMostrar: TAction;
    actMinimizar: TAction;
    Buscar1: TMenuItem;
    ImageList1: TImageList;
    actObtener: TAction;
    actGuardar: TAction;
    actEliminar: TAction;
    actBuscar: TAction;
    actPasarDatos: TAction;
    be: TStatusBar;
    dlAbrir: TOpenDialog;
    BitBtn2: TBitBtn;
    actIniciarTerminalServer: TAction;
    BitBtn3: TBitBtn;
    actVNC: TAction;
    ThemeManager1: TThemeManager;
    LWEB: TLabel;
    tab: TPageControl;
    tabBuscar: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    txtUsuario: TComboBox;
    GroupBox2: TGroupBox;
    txtDatos: TMemo;
    bObtener: TBitBtn;
    BitBtn1: TBitBtn;
    tabModificar: TTabSheet;
    GroupBox3: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    txtModUsuario: TComboBox;
    txtModServidorPref: TComboBox;
    txtModNumConexiones: TEdit;
    txtModNombreCompleto: TEdit;
    bModificar: TBitBtn;
    bEliminar: TBitBtn;
    Panel1: TPanel;
    opPermitirInicioSesion: TCheckBox;
    opMostrarAviso: TCheckBox;
    opCerrarSesionSNPref: TCheckBox;
    tabConfiguracion: TTabSheet;
    GroupBox4: TGroupBox;
    Label5: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    opIniciarMinimizada: TCheckBox;
    opIniciarWindows: TCheckBox;
    txtFichero: TEdit;
    bSelFic: TBitBtn;
    txtUsuarioAdmin: TEdit;
    txtDominio: TEdit;
    opIniciarAdmServicios: TCheckBox;
    opControlRemoto: TCheckBox;
    GroupBox5: TGroupBox;
    bNoPermitirTodos: TBitBtn;
    bPermitirTodos: TBitBtn;
    GroupBox6: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    txtComandoControlRemoto: TEdit;
    txtComandoControlRemotoParametros: TEdit;
    tabUsuariosServidor: TTabSheet;
    Panel2: TPanel;
    bObtenerNumeroUsuarios: TBitBtn;
    lsNumeroUsuariosServidor: TListView;
    procedure FormCreate(Sender: TObject);
    procedure txtUsuarioKeyPress(Sender: TObject; var Key: Char);
    procedure actCerrarExecute(Sender: TObject);
    procedure actMostrarExecute(Sender: TObject);
    procedure actMinimizarExecute(Sender: TObject);
    procedure actObtenerExecute(Sender: TObject);
    procedure actGuardarExecute(Sender: TObject);
    procedure actEliminarExecute(Sender: TObject);
    procedure actBuscarExecute(Sender: TObject);
    procedure actPasarDatosExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bSelFicClick(Sender: TObject);
    procedure actIniciarTerminalServerExecute(Sender: TObject);
    procedure actVNCExecute(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
    procedure bObtenerNumeroUsuariosClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;
  nombreUsuario : string;
  nombreServidor : string;
  nombreEquipoCliente : string;
  numConexiones : integer;
  horaInicio : string;
  nombreCompleto : string;
  nombreServidorPreferido : string;
  PermitirInicioSesion : boolean;
  MostrarAviso : boolean;
  CerrarSesionSNPref : boolean;
  vtServiciosTS : Boolean;
  vtControlRemoto : Boolean;
  vtUsuAdministrador : Boolean;


implementation

{$R *.dfm}

procedure ejecutarFichero (fichero, parametros : string);
var
  resEj : THandle;
begin
  resEj := 0;
  resEj := ShellExecute(resEj, 'open', PChar(fichero),
        PChar(parametros), nil, SW_SHOWNORMAL);
  if resEj < 32 then
  begin
    RaiseLastWin32Error;
  end
  else
  begin
    //'El fichero se ha ejecutado correctamente';
  end;
end;



procedure quitarEjecutarInicio ();
var
  reg: TRegistry;
begin
  reg := TRegistry.Create;
  reg.RootKey := HKEY_LOCAL_MACHINE;
  reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', false);
  reg.DeleteValue(Application.Title);
  reg.CloseKey;
  reg.Free;
end;



procedure ejecutarInicio ();
var
  reg : tregistry;
begin
  Reg := TRegistry.Create(KEY_WRITE);
  try
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Run', True) then
    begin
      try
        Reg.WriteString(Application.Title,
            ExtractFilePath(ParamStr(0)) + ExtractFileName(ParamStr(0)));
      except
        Reg.CloseKey;
        raise;
      end;
    end;
    Reg.CloseKey;
  finally
    Reg.Free;
  end;
end;


function listarClavesINI (fichero : string) : TStringList;
var
  lista : TStringList;
  ltFichero : TStringList;
  i : integer;
  linea : string;
  nombreClave : string;
begin
  lista := TStringList.Create;
  if FileExists(fichero) then
  begin
    ltFichero := TStringList.Create;
    ltFichero.LoadFromFile(fichero);
    for i := 0 to ltFichero.Count - 1 do
    begin
      linea := trim(ltFichero.Strings[i]);
      if pos('[', linea) = 1 then
      begin
        nombreClave := copy(linea, pos('[', linea) + 1, pos(']', linea) - 2);
        lista.Add(nombreClave);
      end;
    end;
  end;
  result := lista;
end;


function listarServidores (fichero : string) : TStringList;
var
  lista : TStringList;
  ltClaves : TStringList;
  i : integer;
  servidorOb : string;
begin
  lista := TStringList.Create;
  lista.Sorted := true;
  lista.Duplicates := dupIgnore;
  if FileExists(fichero) then
  begin
    ltClaves := listarClavesINI (fichero);
    with tinifile.create (fichero) do
    begin
      try
        for i := 0 to ltClaves.Count - 1 do
        begin
          servidorOb := ReadString(ltClaves.Strings[i], 'Servidor', '');
          if servidorOb <> '' then
            lista.Add(servidorOb);
        end;
      finally
        free;
      end;
    end;
  end;
  result := lista;
end;

procedure numeroUsuariosServidor (fichero : string);
var
  ltClaves : TStringList;
  i, numeroUsuarios : integer;
  servidorOb : string;
  ficheroServidores : string;
begin
  if FileExists(fichero) then
  begin
    ltClaves := listarClavesINI (fichero);
    ficheroServidores := IncludeTrailingPathDelimiter(ExtractFilePath(fichero)) + 'servidores.ini';
    if FileExists(ficheroServidores) then
      DeleteFile(ficheroServidores);
    with tinifile.create (fichero) do
    begin
      try
        for i := 0 to ltClaves.Count - 1 do
        begin
          servidorOb := ReadString(ltClaves.Strings[i], 'Servidor', '');
          //nmero actual en fichero INI
          if servidorOb <> '' then
          begin
            with tinifile.create (ficheroServidores) do
            try
              numeroUsuarios := ReadInteger ('Servidores', servidorOb, 0);
            finally
              free;
            end;
            numeroUsuarios := numeroUsuarios + 1;
            //escribimos los datos en el INI de servidores
            with tinifile.create (ficheroServidores) do
            try
              WriteInteger ('Servidores', servidorOb, numeroUsuarios);
            finally
              Free;
            end;
          end;
        end;
      except
      end;
    end;
  end;
end;



procedure TformMenuPrincipal.FormCreate(Sender: TObject);
var
  docInfo : string;
begin
  with tinifile.create (changefileext(paramstr(0), '.ini')) do
  begin
    try
      opIniciarMinimizada.Checked := ReadBool ('Inicio', 'Minimizada', false);
      opIniciarWindows.Checked := ReadBool ('Inicio', 'Windows', false);
      opIniciarAdmServicios.Checked := ReadBool ('Inicio', 'Iniciar servicios TS', false);
      opControlRemoto.Checked := ReadBool ('Inicio', 'Control remoto', false);
      txtFichero.Text := ReadString ('Datos', 'Ubicacin fichero INI', '');
      txtUsuarioAdmin.Text := ReadString ('Inicio', 'Administrador', '');
      txtDominio.Text := ReadString ('Datos', 'Dominio', '');
      txtComandoControlRemoto.Text := ReadString ('Control remoto equipo', 'Comando', '');
      txtComandoControlRemotoParametros.Text := ReadString ('Control remoto equipo', 'Parmetros', '');
    finally
      free;
    end;
  end;

  if HiWord(GetKeyState(VK_SHIFT)) = 0 then //shift no pulsado
  begin
    docInfo := txtFichero.Text;
    txtUsuario.Items := listarClavesINI (docInfo);
    txtModServidorPref.Items := listarServidores(docInfo);
    txtModUsuario.Items := txtUsuario.Items;
    be.Panels[1].Text := inttostr(txtUsuario.Items.Count) + ' usuarios';
    if opIniciarMinimizada.Checked then
      actMinimizarExecute(Self);
  end;
  tabBuscar.Show;
end;

procedure TformMenuPrincipal.txtUsuarioKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = #13 then
    actObtenerExecute(Self);
end;

procedure TformMenuPrincipal.actCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TformMenuPrincipal.actMostrarExecute(Sender: TObject);
begin
  show;
  WindowState := wsNormal;
  actMinimizar.Enabled := true;
  actMostrar.Enabled := false;
  tMin.Hide;
end;

procedure TformMenuPrincipal.actMinimizarExecute(Sender: TObject);
begin
  actMinimizar.Enabled := false;
  actMostrar.Enabled := true;
  Hide;
  Application.ShowMainForm := False;
  tMin.Hint := Application.Title;
  tMin.Show;
end;

procedure TformMenuPrincipal.actObtenerExecute(Sender: TObject);
var
  docInfo : string;
begin
  txtDatos.Clear;
  docInfo := txtFichero.Text;

  if FileExists(docInfo) then
  begin
    nombreUsuario := txtUsuario.Text;
    if nombreUsuario <> '' then
    begin
      with tinifile.create (docInfo) do
      try
        numConexiones := ReadInteger (nombreUsuario, 'N Conexiones', 0);
        nombreServidor := readString (nombreUsuario, 'Servidor', '');
        nombreEquipoCliente := ReadString (nombreUsuario, 'Equipo cliente', '');
        horaInicio := ReadString (nombreUsuario, 'Hora Inicio sesion', '');
        nombreCompleto := ReadString (nombreUsuario, 'Nombre completo', '');
        nombreServidorPreferido := ReadString (nombreUsuario, 'Servidor preferido', '');
        PermitirInicioSesion := readBool (nombreUsuario, 'Permitir inicio sesin', true);
        MostrarAviso := readBool (nombreUsuario, 'Mostrar aviso', false);
        CerrarSesionSNPref := readBool (nombreUsuario, 'Cerrar sesin', false);

        vtServiciosTS := ReadBool (nombreUsuario, 'Iniciar servicios TS', false);
        vtControlRemoto := ReadBool (nombreUsuario, 'Control remoto', false);
        vtUsuAdministrador := ReadBool (nombreUsuario, 'Administrador', false);

        txtDatos.Lines.Add('Servidor actual: ' + nombreServidor);
        txtDatos.Lines.Add('Servidor preferido: ' + nombreServidorPreferido);
        txtDatos.Lines.Add('N conexiones: ' + IntToStr(numConexiones));
        txtDatos.Lines.Add('Equipo cliente: ' + nombreEquipoCliente);
        txtDatos.Lines.Add('Nombre completo: ' + nombreCompleto);
        txtDatos.Lines.Add('Inicio sesin: ' + horaInicio);
        if PermitirInicioSesion then
          txtDatos.Lines.Add('Permitir inicio de sesin: S')
        else
          txtDatos.Lines.Add('Permitir inicio de sesin: No');
        if MostrarAviso then
          txtDatos.Lines.Add('Mostrar aviso si no es su servidor: S')
        else
          txtDatos.Lines.Add('Mostrar aviso si no es su servidor: No');
        if CerrarSesionSNPref then
          txtDatos.Lines.Add('Cerrar sesin si no es su servidor: S')
        else
          txtDatos.Lines.Add('Cerrar sesin si no es su servidor: No');
        if vtUsuAdministrador then
          txtDatos.Lines.Add('Administrador: S')
        else
          txtDatos.Lines.Add('Administrador: No');
        if vtServiciosTS then
          txtDatos.Lines.Add('Iniciar administrador Servicios TS: S')
        else
          txtDatos.Lines.Add('Iniciar administrador Servicios TS: No');
        if vtControlRemoto then
          txtDatos.Lines.Add('Hacer control remoto: S')
        else
          txtDatos.Lines.Add('Hacer control remoto: No');
      finally
        free;
      end;
    end
    else
    begin
      MessageDlg('Debe indicar el nombre de usuario a consultar.',
          mtInformation, [mbok], 0);
      txtUsuario.SetFocus;
    end;
  end
  else
    MessageDlg('El fichero de informacin: ' + chr(13) + chr(13) + docInfo +
        chr(13) + chr(13) + ' no existe o no es accesible.',
        mtWarning, [mbok], 0);
end;

procedure TformMenuPrincipal.actGuardarExecute(Sender: TObject);
var
  nombreUsuario : string;
  docInfo : string;
begin
  docInfo := txtFichero.Text;
  if FileExists(docInfo) then
  begin
    nombreUsuario := txtUsuario.Text;
    if nombreUsuario <> '' then
    begin
      with tinifile.create (docInfo) do
      try
        if txtModNumConexiones.Text <> '' then
          WriteInteger (nombreUsuario, 'N Conexiones', strtoint(txtModNumConexiones.Text));
        WriteString (nombreUsuario, 'Nombre completo', txtModNombreCompleto.Text);
        WriteString (nombreUsuario, 'Servidor preferido', txtModServidorPref.Text);
        WriteBool (nombreUsuario, 'Permitir inicio sesin', opPermitirInicioSesion.Checked);
        WriteBool (nombreUsuario, 'Mostrar aviso', opMostrarAviso.Checked);
        WriteBool (nombreUsuario, 'Cerrar sesin', opCerrarSesionSNPref.Checked);
        MessageDlg('Datos guardados correctamente.',
            mtInformation, [mbok], 0);
      finally
        free;
      end;
    end
    else
    begin
      MessageDlg('Debe indicar el nombre de usuario a consultar.',
          mtInformation, [mbok], 0);
      txtUsuario.SetFocus;
    end;
  end
  else
    MessageDlg('El fichero de informacin: ' + chr(13) + chr(13) + docInfo +
        chr(13) + chr(13) + ' no existe o no es accesible.',
        mtWarning, [mbok], 0);
end;

procedure TformMenuPrincipal.actEliminarExecute(Sender: TObject);
begin
//
end;

procedure TformMenuPrincipal.actBuscarExecute(Sender: TObject);
begin
  actMostrarExecute(Self);
  tabBuscar.Show;
  txtUsuario.SetFocus;
  txtUsuario.SelectAll;
end;

procedure TformMenuPrincipal.actPasarDatosExecute(Sender: TObject);
begin
  txtModUsuario.Text := nombreUsuario;
  txtModServidorPref.Text := nombreServidorPreferido;
  txtModNombreCompleto.Text := nombreCompleto;
  txtModNumConexiones.Text := inttostr(numConexiones);
  opPermitirInicioSesion.Checked := PermitirInicioSesion;
  opMostrarAviso.Checked := MostrarAviso;
  opCerrarSesionSNPref.Checked := CerrarSesionSNPref;
  tabModificar.Show;
  txtModServidorPref.SetFocus;
end;

procedure TformMenuPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  with tinifile.create (changefileext(paramstr(0), '.ini')) do
  begin
    try
      WriteBool ('Inicio', 'Minimizada', opIniciarMinimizada.Checked);
      WriteBool ('Inicio', 'Windows', opIniciarWindows.Checked);
      WriteBool ('Inicio', 'Iniciar servicios TS', opIniciarAdmServicios.Checked);
      WriteBool ('Inicio', 'Control remoto', opControlRemoto.Checked);
      WriteString ('Inicio', 'Administrador', txtUsuarioAdmin.Text);
      WriteString ('Datos', 'Ubicacin fichero INI', txtFichero.Text);
      WriteString ('Datos', 'Dominio', txtDominio.Text);
      WriteString ('Control remoto equipo', 'Comando', txtComandoControlRemoto.Text);
      WriteString ('Control remoto equipo', 'Parmetros', txtComandoControlRemotoParametros.Text);
    finally
      free;
    end;
  end;

  //para el usuario administrador
  if FileExists(txtFichero.Text) and (txtUsuarioAdmin.Text <> '') then
  begin
    with tinifile.create (txtFichero.Text) do
    begin
      try
        WriteBool (txtUsuarioAdmin.Text, 'Iniciar servicios TS', opIniciarAdmServicios.Checked);
        WriteBool (txtUsuarioAdmin.Text, 'Control remoto', opControlRemoto.Checked);
        WriteBool (txtUsuarioAdmin.Text, 'Administrador', true);
        WriteString (txtUsuarioAdmin.Text, 'Usuario control remoto', nombreUsuario);
      finally
        free;
      end;
    end;
  end;


  if opIniciarWindows.Checked then
    ejecutarInicio
  else
    quitarEjecutarInicio;
end;

procedure TformMenuPrincipal.bSelFicClick(Sender: TObject);
begin
  if dlAbrir.Execute then
    txtFichero.Text := dlAbrir.FileName;
end;

procedure TformMenuPrincipal.actIniciarTerminalServerExecute(
  Sender: TObject);
var
  rutaFicheroConexion : string;
  contenido : TStringList;
begin
  if txtUsuarioAdmin.Text = '' then
  begin
    MessageDlg('Debe indicar el nombre del usuario ' +
        'con el que se conectar al servidor.', mtInformation, [mbok], 0);
    tabConfiguracion.Show;
    txtUsuarioAdmin.SetFocus;
    exit;
  end;

  if FileExists(txtFichero.Text) then
  begin
    rutaFicheroConexion := ExtractFilePath (Application.ExeName) +
        'conexion.rdp';
    contenido := TStringList.Create;
    contenido.Add ('screen mode id:i:2');
    //contenido.Add ('desktopwidth:i:800');
    //contenido.Add ('desktopheight:i:600');
    contenido.Add ('session bpp:i:8');
    contenido.Add ('winposstr:s:0,1,0,0,800,566');
    contenido.Add ('full address:s:' + nombreServidor);
    contenido.Add ('compression:i:1');
    contenido.Add ('keyboardhook:i:2');
    contenido.Add ('audiomode:i:2');
    contenido.Add ('redirectdrives:i:0');
    contenido.Add ('redirectprinters:i:1');
    contenido.Add ('redirectcomports:i:0');
    contenido.Add ('redirectsmartcards:i:1');
    contenido.Add ('displayconnectionbar:i:1');
    contenido.Add ('autoreconnection enabled:i:1');
    contenido.Add ('username:s:' + txtUsuarioAdmin.Text);
    contenido.Add ('domain:s:' + txtDominio.Text);
    contenido.Add ('alternate shell:s:');
    contenido.Add ('shell working directory:s:');
    contenido.Add ('disable wallpaper:i:1');
    contenido.Add ('disable full window drag:i:1');
    contenido.Add ('disable menu anims:i:1');
    contenido.Add ('disable themes:i:1');
    contenido.Add ('disable cursor setting:i:0');
    contenido.Add ('bitmapcachepersistenable:i:1');
    contenido.SaveToFile(rutaFicheroConexion);

    with tinifile.create (txtFichero.Text) do
    begin
      try
        WriteBool (txtUsuarioAdmin.Text, 'Iniciar servicios TS', opIniciarAdmServicios.Checked);
        WriteBool (txtUsuarioAdmin.Text, 'Control remoto', opControlRemoto.Checked);
        WriteBool (txtUsuarioAdmin.Text, 'Administrador', true);
        WriteString (txtUsuarioAdmin.Text, 'Usuario control remoto', nombreUsuario);
      finally
        free;
      end;
    end;
    ejecutarFichero ('mstsc.exe', '"' + rutaFicheroConexion + '"');
  end
  else
  begin
    tabConfiguracion.Show;
    txtFichero.SetFocus;
    MessageDlg('No existe el fichero de configuracin de los ' +
        'usuarios. Debe indicarlo previamente.', mtInformation, [mbok], 0);
  end;
end;

procedure TformMenuPrincipal.actVNCExecute(Sender: TObject);
var
  resEj : Cardinal;
  parametrosP1, parametrosP2 : string;
  parametros : string;
begin
  parametros := txtComandoControlRemotoParametros.Text;
  parametrosP1 := copy (parametros, 1, Pos ('<<<IP>>>', parametros) - 1);
  parametrosP2 := copy (parametros, Pos ('<<<IP>>>', parametros) + 8, length(parametros));
  parametros := parametrosP1 + nombreEquipoCliente + parametrosP2; 
  resEj := ShellExecute(Handle, 'open', PChar(txtComandoControlRemoto.Text),
        PChar(parametros), nil, SW_SHOWNORMAL);
  if resEj < 32 then
  begin
    MessageDlg ('Se ha producido un error al intentar ejecutar ' +
        'el programa de control remoto.', mtWarning, [mbok], 0);
    RaiseLastWin32Error;
  end;
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.bObtenerNumeroUsuariosClick(Sender: TObject);
var
  ListItem : TListItem;
  lstServidores : TStringList;
  i, numeroUsuarios : integer;
  ficheroServidores : string;
begin
  numeroUsuariosServidor(txtFichero.Text);
  lsNumeroUsuariosServidor.Clear;
  ficheroServidores := IncludeTrailingPathDelimiter(ExtractFilePath(txtFichero.Text)) + 'servidores.ini';
  if FileExists(ficheroServidores) then
  begin
    lstServidores := listarServidores(txtFichero.Text);
    for i := 0 to lstServidores.Count - 1 do
    begin
      with tinifile.create (ficheroServidores) do
      try
        try
          numeroUsuarios := ReadInteger ('Servidores', lstServidores.Strings[i], 0);
          ListItem := lsNumeroUsuariosServidor.Items.Add;
          ListItem.Caption := lstServidores.Strings[i];
          ListItem.SubItems.Add(inttostr(numeroUsuarios));
        except
        end;
      finally
        free;
      end;
    end;
  end;
end;

end.
